; Experiments within 32 bytes
; (C)2019 - Thomas Jentzsch
; Cosmic Ark stars variations

    processor 6502
    include "vcs.h"

USE_BALL    = 0

    ORG $f800
Start
.mainLoop

  IF USE_BALL
    lda #%01110011      ; or 01110010
    sta ENABL
  ELSE
    lda #%01110011
    sta GRP0
  ENDIF
    sta AUDC0
                         ; A: "moving"
;    iny                 ; B: "mixed effect down"
;    dey                 ; C: "mixed effect up"
.loopKernel
  IF USE_BALL
    sty HMBL
  ELSE
    sty HMP0
  ENDIF
;    iny                 ; D: "random lame" (depends on initial X/Y)
    dey                 ; E: "random effect" (depends on initial X/Y)
.waitVSync
;    iny                 ; F: "chaos"
;    dey                 ; G: "effect"
    stx AUDV0
    sty AUDF0           ; stX works differently
    sta WSYNC
    sta HMOVE
    lsr
    sta VSYNC
    bne .waitVSync
  IF USE_BALL
    sty COLUPF
  ELSE
    sty COLUP0
  ENDIF
    sta HMCLR           ; enable stars effect
    dey
    dex
    bne .loopKernel
    beq .mainLoop

    ECHO "Size:", [. - Start]d, "bytes"

    ORG $fffc, 0
    .word   Start
    .word   Start